#!/usr/bin/env python
# -*- coding: utf-8 -*-

from sigpdv.tools.config import config
from sigpdv.tools.log import traced as Log
from sigpdv.thread import th
from sigpdv.models.db_utils import testa_conexao_pg, pemite_testar_conexao
import time


class Conexao(object):
    conectado = False
    primeira = True
    def checar_conexao(self, tempo=3):
        def is_connected():
            if not pemite_testar_conexao.get('valor'):
                return

            res = testa_conexao_pg(config['db_sup_name'], config['db_sup_user'],
                                   config['db_sup_host'], config['db_sup_pass'])
            if self.conectado and res or (not self.conectado and not res) and not self.primeira:
                return

            self.primeira =False
            file = open('/tmp/conexao_frente.txt', 'w')
            if res:
                file.write('1')
                self.conectado = True
            else:
                file.write('0')
                self.conectado = False

            file.close()

        Log.info('checar_conexao(tempo=%r)' % tempo)
        back = th.BackgroundTask
        back(tempo, is_connected).start()
        while True:
            time.sleep(3)

Conexao().checar_conexao()