#!/usr/bin/python
# -*- encoding: utf-8 -*-

__autor__ = 'Dener Rodrigues'

pkey_sig = """-----BEGIN RSA PRIVATE KEY-----
MIICXQIBAAKBgQDNlPEHacb00nIQ7rrZ3U4kL9QAU+vvXbLLHGR45+7zYb2cBE2s
qmnUpSgf2Jp2HL0Dz/paqxpB4pOxU6kEcDs1QOlTjt5rTsKKiw6Of7g1MsrIEQCz
tF+u8xXyl93JB0M2QBQ4PGVQQsHxyd+jdWHCOj/YpJCA/8rJUbhiVoRaQwIDAQAB
AoGBAMnIdUO3eUb4AGnKSLBq3bX7E/U2ag/KQiHGPn/F9u4Ac6FdP/hIVBQZ/2Yy
rnlb/9JsIuk3pFAi2qBk4zKuDg2V57DY+h31SLVjENZHD3M0MGonFzu1uay+s/m0
X0mMbueNXuWAAYkoAPL/wEjP/ciJkqfCUiOJADcf7PJhXfhxAkEA9F1mdw+z+GPu
tHabZ2WJJSb7JnZtAskG/spFye6UUUw53tC7mLZ7Ye3dESa3l9jtRfC4CSKbNJhX
9JyTkzcabQJBANdezxdVg4gbBbdBm6cf59aT7Y1KIrqkDtQpENBJVMXJUIa2CTEc
QvGE3UwOA37zLRFtkSZk0w1590wC7NkwWW8CQBmr+kjF0I1myjwRPdBF/Xt2tenb
hSZGwkJgM6a8Nr63uFitKxgnC51FJPVZUO5V7s9rM5paFV4YJx1ema5cmp0CQQCo
gwgqS8CEqBAK2Qy+8RnnLQt7t3wA6QipPBBpyFbKAsA9BwWeJWzDqJ+2OGjH1eF3
d3FQxybTrpCuKsPDFC+FAkALWOoMA+liEcsz/n7BardljL0BRDuqMaS2iuQ/RTAH
34xfgVdzAN8XNLA+FOAWMxyDxP1vfoa6SwUsTZsdebGa
-----END RSA PRIVATE KEY-----"""

import os
import sys
import commands
import subprocess
import traceback
import ConfigParser
from decimal import Decimal
from sigpdv.control.utils import md5_file
from exceptions import Exception
from datetime import datetime, timedelta
from sigpdv import root_path
from sigpdv.control.utils import reload_app, set_serial, get_loja as get_loja_id
from sigpdv.tools.log import traced as Log
from sigpdv.tools.config import config
from sigpdv.models.cfg_ecf_autorizada_data import CaixaCfgEcfAutorizada
from sigpdv.models.cad_finzalizadora_na_ecf_data import CaixaCadFinalizadoraNaEcf
from sigpdv.models.db_utils import exec_sql
from sigpdv.ui.dlpPwd import password_dlg
from sigpdv.ui.messagebox import YES_ROLE, MSG_ERROR, MSG_QUESTION, MSG_INFO, message_dlg
from SigUtils.crypto import verifica_assinatura, decrypt, crypt
from kiwi.python import Settable
from stoqdrivers.serialbase import SerialPort
from stoqdrivers.printers.fiscal import FiscalPrinter
from stoqdrivers.exceptions import DriverError, CommandError, \
    CouponOpenError, PendingReduceZ, HardwareFailure, \
    PrinterOfflineError, ItemAdditionError, CancelItemError, \
    PdvConnectionError, PrinterGTError, InvalidState, PrinterSerialError, \
    PrinterFileError, CommError, PaymentAdditionError, CodigoInvalido, AlreadyTotalized, \
    EcfDateError, CouponNotOpenError, OutofPaperError, TimeoutError, AlmostOutofPaper, \
    CouponNoFiscalOpenError


class FiscalPrinterHelper(object):
    def __init__(self, parent=None, check_serial=False):
        if check_serial:
            set_serial()
        self.parent = parent
        self.printer = self.get_printer()

    @Log
    def send_command(self, cmd, test_status_time_out=True, qtd_tentativas=30, z_pendente=False):
        if cmd.startswith(('open', 'cancel', 'summarize', 'gerencial_report_open', 'close_till',
                           'till_add_cash', 'till_remove_cash', 'till_read_memory',
                           'till_read_memory_by_reductions')):

            if z_pendente and not cmd.startswith(('cancel', 'close_till')):
                return message_dlg(self.parent, MSG_INFO,
                                   'Z Pendente. Favor Efetuar a Redução Z para efetuar '
                                   'esta operação')

        loop = 0
        while True:
            loop += 1
            try:
                ret = eval("self.printer.%s" % cmd)
                return ret
            except TimeoutError as err:
                if not test_status_time_out:
                    raise TimeoutError(str(err))
                Log.error("Erro: '%s', Comando: %s. Vou aguarda 1 segundos e tentar novamente %d"
                          % (str(err), cmd, loop))
                if loop == qtd_tentativas:
                    raise TimeoutError('Foram feitas %d tentativas, e não foi possível comunicar '
                                       'com o ECF.' % loop)
                continue

            except (CodigoInvalido, CouponNotOpenError, CancelItemError, AlreadyTotalized,
                    CouponOpenError, ItemAdditionError) as err:
                raise err

            except OutofPaperError:
                raise OutofPaperError('Impressora sem papel!')

            except CouponNoFiscalOpenError as e:
                Log.error("%s" % e)
                # cancela o cupom nao fiscal
                self.printer.cancel_last_coupon()
                coo = self.printer.get_coo()
                message_dlg(self, MSG_INFO, 'Erro: %s\n Cupom não fiscal %s cancelado.' %
                            ("%s" % e,coo))
                raise e

            except (DriverError, ValueError), err:
                if not test_status_time_out:
                    raise TimeoutError(str(err))

                if err.message == 'Dados da última RZ corrompidos':
                    msg = 'Não foi possível enviar o comando para a ECF\n\nTENTAR NOVAMENTE?'
                    if message_dlg(self.parent, MSG_QUESTION, msg, str(err.message)) != YES_ROLE:
                        return False

                elif err.message == 'Totalizador sem alíquota programada':
                    raise err

                Log.error("Erro: '%s', Comando: %s. Vou aguarda 1 segundos e tentar novamente %d"
                          % (str(err), cmd, loop))

                if loop == qtd_tentativas:
                    raise TimeoutError('Foram feitas %d tentativas, e não foi possível comunicar '
                                       'com o ECF.' % loop)
                continue

            except Exception as err:
                raise err

        return None

    @Log
    def get_printer(self):
        printer = None
        loja = config['loja']
        caixa = config['caixa']
        ecf = self.get_ecf_autorizada(loja, caixa, os.path.join(root_path, 'pdvsig.sig'), True)
        ecf_fabricante = (ecf.CFabricante or '').lower()

        if 'bematech' in ecf_fabricante:
            brand = 'bematech'
            if '4000' in ecf.CModelo:
                model = 'MP4000'
            else:
                model = 'MP2100'

        elif 'daruma' in ecf_fabricante:
            brand = 'daruma'
            model = 'FS600MFD'

        elif 'dataregis' in ecf_fabricante:
            brand = 'dataregis'
            model = 'EP375'

        elif 'elgin' in ecf_fabricante:
            brand = 'elgin'
            model = 'ELGINK'

        elif 'sweda' in ecf_fabricante:
            brand = 'sweda'
            model = 'IFS9000I'

        elif 'epson' in ecf_fabricante:
            raise Exception('ECF EPSON nao suportada')

        elif 'zpm' in ecf_fabricante:
            raise Exception('ECF ZOM nao suportada')

        elif 'urano' in ecf_fabricante:
            raise Exception('ECF URANO nao suportada')

        else:
            raise Exception('Fabricante da ECF não identificado no Arquivo de Configuração')

        try:
            port = SerialPort(config['ecf'])
            port.set_options(baudrate=config['printer_speed_port'])
            printer = FiscalPrinter(brand=brand, model=model, port=port)
            if brand == 'sweda':
                try:
                    printer._driver.writeline('', 0)
                except Exception, e:
                    Log.info(str(e))
            # este teste trata o erro que acontece ao ligar a ECF Elgin antes de ligar o computador,
            # a primeira comunicacao ocorre Timeout, depois comunica normalmente.
            if brand == 'elgin':
                port.setTimeout(0.1)
                try:
                    printer.get_status()
                except:
                    pass

                port.setTimeout(1)

        except Exception as e:
            traceback.print_exc()
            if self.parent:
                self.parent.QtGui.QApplication(sys.argv)
                message_dlg(self.parent, MSG_ERROR, 'A Aplicação será encerrada', str(e))
                sys.exit()

        return printer

    @Log
    def get_printer_status(self, loja, caixa, check_date=True):
        ecf = self.get_ecf_autorizada(loja, caixa, 'pdvsig.sig', True)
        if not ecf.Check_Sign:
            raise PrinterFileError('O Arquivo o Auxiliar do ECF foi alterado.')

        if not ecf.CNSerie == self.printer._serial:
            raise PrinterSerialError(
                'Numero de Série da Impressora [%s] difere do armazenado [%s].' % (
                    ecf.CNSerie, self.printer._serial))

        self.checar_gt()
        if check_date is True:
            self.check_ecf_date()

        retval = self.printer.send_command(1, raw=True)
        status = self.printer.get_status(retval)
        if status.block_z:
            raise PendingReduceZ('Bloqueio por Redução Z')
        if status.open:
            raise CouponOpenError('Cupom Aberto')
        if status.off_line:
            raise PrinterOfflineError('Impressora Off-Line')
        if status.out_paper:
            raise AlmostOutofPaper("Impressora quase sem papel")
        try:
            status.check_error()
        except CommandError:
            pass

        return retval

    @Log
    def get_ecf_autorizada(self, loja, caixa, arquivo, _file=False):
        arquivo = os.path.join(root_path, arquivo)
        if not os.path.exists(arquivo) and _file:
            Log.info(str('[Errno 2] Arquivo de Identificação da ECF não encontrado: %s' % arquivo))
            raise PrinterGTError('Arquivo Auxiliar Nao Encontrado')

        elif not _file:
            tbl_ecf = CaixaCfgEcfAutorizada.get_by(supecf_loja=loja, supecf_caixa=caixa)
            if tbl_ecf:
                ecfs = Settable(Empresa=get_loja_id().supcfc_cliente,
                                No_Serie_Cliente='',
                                CFabricante=tbl_ecf.supecf_fabricante,
                                CModelo=tbl_ecf.supecf_modelo,
                                CVersao=tbl_ecf.supecf_versao,
                                CDataSB=tbl_ecf.supecf_data_sb,
                                CHoraSB=tbl_ecf.supecf_hora_sb,
                                CNSerie=tbl_ecf.supecf_nserie,
                                CNacional=tbl_ecf.supecf_nacional,
                                md5=tbl_ecf.supecf_md5,
                                Sign=tbl_ecf.supecf_sign,
                                Check_Sign=True)
                return ecfs

        try:
            con = ConfigParser.ConfigParser()
            con.read(arquivo)
            section = '%.4d%.3d' % (loja, caixa)
            cfabricante = con.get(section, 'CFabricante')
            cmodelo = con.get(section, 'CModelo')
            cversao = con.get(section, 'CVersao')
            cdatasb = con.get(section, 'CDataSB')
            chorasb = con.get(section, 'CHoraSB')
            cnserie = con.get(section, 'CNSerie')
            cnacional = con.get(section, 'CNacional')
            md5 = con.get(section, 'md5')
            sign = con.get(section, 'Sign')
            message = '%s%s%s%s%s%s%s' % (cfabricante, cmodelo, cversao, cdatasb,
                                          chorasb, cnserie, cnacional)

            try:
                sign_ok = verifica_assinatura(message.decode('utf-8'), sign, pkey_sig)
            except:
                raise PrinterFileError('O arquivo de configuracao do ECF foi alterado')

            if not sign_ok:
                raise PrinterFileError('O arquivo de configuracao do ECF foi alterado')

            ecfs = Settable(Empresa=con.get('Identificacao', 'Empresa').decode('utf-8'),
                            No_Serie_Cliente=con.get('Identificacao', 'No_Serie_Cliente'),
                            CFabricante=decrypt(cfabricante, pkey_sig),
                            CModelo=decrypt(cmodelo, pkey_sig),
                            CVersao=decrypt(cversao, pkey_sig),
                            CDataSB=decrypt(cdatasb, pkey_sig),
                            CHoraSB=decrypt(chorasb, pkey_sig),
                            CNSerie=decrypt(cnserie, pkey_sig),
                            CNacional=decrypt(cnacional, pkey_sig),
                            md5=md5,
                            Sign=sign,
                            Check_Sign=sign_ok)

        except ConfigParser.NoSectionError:
            raise Exception('Impressora nao identificada para a '
                            'loja: %d Caixa: %d' % (loja, caixa))

        return ecfs

    @Log
    def get_ecfs_autorizadas(self):
        """
        Lê o arquivo pdvsig.sig e retorna uma lista com o Número de Série de cada ECF.

        :rtype list
        """
        retval = []

        arq = open(os.path.join(root_path, 'pdvsig.sig'), 'r')
        arq_lines = arq.readlines()
        arq.close()

        for line in arq_lines:
            try:
                if line[:7] == 'CNSerie':
                    loja = int(arq_lines[arq_lines.index(line) - 7][1:5])
                    caixa = int(arq_lines[arq_lines.index(line) - 7][5:8])
                    ecf_autorizada = self.get_ecf_autorizada(loja, caixa, 'pdvsig.sig', True)
                    retval.append(ecf_autorizada.CNSerie)
            except:
                pass

        return retval

    @Log
    def checar_gt(self, file_gt='gt.sig'):
        try:
            gt_ecf = self.send_command("get_grande_total()")
        except Exception as e:
            Log.error('Erro ao pegar GT: %s' % e)
            gt_ecf = Decimal(0)

        file_gt = os.path.join(root_path, 'gt.sig')
        checar = False

        if os.path.exists(file_gt):
            file_lines = open(file_gt, 'r').readlines()
            try:
                if Decimal(crypt(file_lines[1], 'D')) != gt_ecf:
                    checar = True
            except Exception:
                checar = True
        else:
            checar = True

        if checar:
            sql = """
            SELECT t1.supcap_crz,
                   t1.supcap_nro_cupom,
                   t2.supcxz_cro,
                   t2.supcxz_gt_atual  -  t2.supcxz_gt_anterior VBD
            FROM   caixa_mov_capa t1,
                   caixa_mov_corpo_xz t2
            WHERE  t1.supcap_nro_cupom = (SELECT Max(supcap_nro_cupom)
                                          FROM   caixa_mov_capa
                                          WHERE  supcap_tipo = 'Z'
                                                 AND supcap_loja = %s
                                                 AND supcap_caixa = %s)
                   AND t2.supcxz_capa_id = t1.id;""" % (config['loja'], config['caixa'])
            last_z_db = exec_sql(sql, 'C')
            last_z_ecf = self.send_command("get_last_reduce()")

            # Informações da ECF
            cro_ecf = last_z_ecf['CRO']
            crz_ecf = last_z_ecf['CRZ']
            vbd_ecf = last_z_ecf['VBD']

            if last_z_db:
                print last_z_db
                # Informações do Banco de Dados
                last_z_db = last_z_db[0]
                cro_db = last_z_db['supcxz_cro']
                crz_db = last_z_db['supcap_crz']
                vbd_db = last_z_db['vbd']

                # Se o CRO da ECF for maior que o do banco recuperar gt
                print (cro_db, crz_db, vbd_db), (cro_ecf, crz_ecf, vbd_ecf), '-', cro_ecf, cro_db
                if (cro_db, crz_db, vbd_db) == (cro_ecf, crz_ecf, vbd_ecf) or cro_ecf > cro_db:
                    print 'INFORMAÇÔES DA ECF COM BASE OK'
                    return self.update_file_gt()
                else:
                    print 'INFORMAÇÔES DA ECF COM BASE DIFERE'
                    return self.gt_remoto(self.send_command("get_serial()"), cro_db, crz_db, vbd_db,
                                          cro_ecf, crz_ecf, vbd_ecf)
            else:
                print 'SEM INFORMAÇÕES NA BASE'
                return self.gt_remoto(self.send_command("get_serial()"),
                                      0, 0, 0, cro_ecf, crz_ecf, vbd_ecf)
        return True

    @Log
    def gt_remoto(self, serial, cro_db, crz_db, vbd_db, cro_ecf, crz_ecf, vbd_ecf):
        from socket import socket, AF_INET, SOCK_STREAM

        serverHost = config['db_sup_host']
        serverPort = 5019

        s = socket(AF_INET, SOCK_STREAM)
        try:
            s.connect((serverHost, serverPort))
        except Exception as e:
            seq = ''.join(('%04d' % config['loja'],
                           '%03d' % config['caixa'],
                           '%03d' % cro_db,
                           '%03d' % cro_ecf,
                           '%04d' % crz_db,
                           '%04d' % crz_ecf))

            seq_list = []
            i = 0
            for x in range(7):
                seq_list.append(seq[i:i + 3])
                i += 3

            seq_list.append('%d' % (vbd_db * Decimal('1e2')))
            seq_list.append('%d' % (vbd_ecf * Decimal('1e2')))

            if password_dlg(senha=seq_list).retval:
                return self.update_file_gt()
            else:
                raise Exception('Não foi possível recuperar o GT/CRZ/CRO remotamente: %s' % e)
        cmd = 'recomporgt --num-serie=%s --crz-ecf=%d --crz-db=%d --cro-ecf=%d --cro-db=%d --vbd-ecf=%d --vbd-db=%d' % \
              (serial, crz_ecf, crz_db, cro_ecf, cro_db, vbd_ecf, vbd_db)
        s.send('EXECUTAR:%s' % cmd)
        data = s.recv(1024)
        if data.startswith('OK!'):
            return self.update_file_gt()
        return False

    @Log
    def update_file_gt(self, file_gt='gt.sig', qtd_tentativas=3):
        file_gt = os.path.join(root_path, 'gt.sig')
        try:
            serial = self.send_command("get_serial()", qtd_tentativas=qtd_tentativas)
        except Exception as e: # trata erro quando o computador liga depois da ECF Elgin
            Log.error("Primeira comunicacao: %s" % str(e))
            serial = self.send_command("get_serial()", qtd_tentativas=qtd_tentativas)

        gt = self.send_command("get_grande_total()", qtd_tentativas=qtd_tentativas)
        txt = '%s\n%s\n%s\n' % (crypt(serial, 'C'),
                                crypt(str(gt), 'C'),
                                crypt(md5_file('lista_de_aplicativos.txt'), 'C'))
        f = open(file_gt, 'w')
        f.write(txt)
        f.close()
        return gt

    @Log
    def check_ecf_date(self, mdiff=15):
        def _diff():
            dif = 0
            if hour_printer > hour_system:
                dif = hour_printer - hour_system
            elif hour_printer < hour_system:
                dif = hour_system - hour_printer
            return dif

        diff_max = timedelta(minutes=mdiff)
        hour_printer = self.get_data_ecf()
        hour_system = datetime.now()
        diff = _diff()

        if diff < diff_max:
            return True

        now_system = hour_system.strftime('%d-%m-%Y %H:%M ')
        now_printer = hour_printer.strftime('%d-%m-%Y %H:%M ')

        msg = '\n\n'
        msg += 'Data do Sistema......: %s\n' % now_system
        msg += 'Data da Impressora: %s\n' % now_printer
        msg += 'Diferença...................: %s\n' % diff

        if message_dlg(self.parent, MSG_QUESTION,
                       'Hora do sistema difere com a Hora do ECF.'
                       '\nDeseja alterar a Hora do sistema?', str(msg)) == YES_ROLE:
            dlg = password_dlg(self.parent, msg_info='Alterar Data do sistema para %s' % now_printer)
            if dlg.retval:
                erro = ''
                if commands.getoutput('whoami') not in ['caixa', 'supersig', 'sig']:
                    cmd = "%s '%s'" % (config['cmd_alterar_data'],
                                       hour_printer.strftime('%Y-%m-%d %H:%M:%S'))
                    sp = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE,
                                          stderr=subprocess.PIPE)
                    erro = sp.stderr.read()
                else:
                    cmd = "echo 'sig' | sudo -S %s '%s'" % (config['cmd_alterar_data'],
                                                            hour_printer.strftime('%Y-%m-%d %H:%M:%S'))
                    if 'incorrect password' in commands.getoutput(cmd):
                        erro = 'incorrect password attempt'

                if erro:
                    message_dlg(self.parent, MSG_ERROR,
                                'Não foi possível alterar a hora do Sistema.\n'
                                'Verifique as configurações de Data/Hora '
                                'do seu computador!\n\n%s' % erro)
                    sys.exit(-1)

                return reload_app(root_path)

        return False

    @Log
    def get_data_ecf(self, mostra_msg=True):
        data = None
        qtd_tentativas = 0
        while not data:
            qtd_tentativas += 1
            try:
                data = self.send_command("get_ecf_date()")
            except Exception as e:
                data = None
                Log.error('Erro ao pegar data da ECF: %s' % str(e))
            if not data or qtd_tentativas == 100:
                break

        if not data and self.parent:
            if not mostra_msg:
                return None

            msg = 'Não foi possível recuperar a data do ECF\n\nTENTAR NOVAMENTE?'
            ret = message_dlg(self.parent, MSG_QUESTION, msg)
            if ret == YES_ROLE:
                data = self.get_data_ecf()
            else:
                data = datetime.now()

        # '_date_coupon' era atualizado apenas ao abrir o frente. Quando o caixa ficava mais
        #  de um dia aberto, o cupom era gravado com data errada.
        if self.parent:
            self.parent._date_coupon = data.date()

        return data

    @Log
    def get_status_gaveta(self):
        status_gaveta = self.send_command('get_status_cash_drawer()')
        if config['invertesinalgaveta']:
            status_gaveta = not status_gaveta
        if status_gaveta:
            raise Exception('Gaveta Aberta')
        return status_gaveta

    @Log
    def add_value_to_counter(self, _type, value, supfin_tipo_finalizadora, text=''):
        tipos = dict([
            ('D', config['sangria_dinheiro']),
            ('H', config['sangria_cheque']),
            ('C', config['sangria_cartao']),
            ('T', config['sangria_ticket']),
            ('O', config['sangria_outros'])
        ])
        nomes_f = dict([
            ('D', 'Dinheiro'),
            ('H', 'Cheque'),
            ('C', 'Cartao'),
            ('T', 'Ticket'),
            ('O', 'Outros')
        ])
        nome_f = nomes_f.get(supfin_tipo_finalizadora)
        emit_erro = False
        par_s = tipos.get(supfin_tipo_finalizadora).split(',')
        if not par_s:
            emit_erro = True
        elif len(par_s) != 2:
            emit_erro = True
        elif not par_s[0] or not par_s[1]:
            emit_erro = True
        if emit_erro:
            erro_msg = 'O Paramêtro para Sangria %s está configurado incorretamente no PDV-Config' \
                       '\n' % nome_f
            message_dlg(self.parent, MSG_ERROR, 'Não foi possível efetuar a sangria de %s' % nome_f,
                        erro_msg)
            return False

        finalizadora = CaixaCadFinalizadoraNaEcf.get_by(supfec_codigo_na_ecf=par_s[1])
        if not finalizadora:
            self.parent.show_info_proccess(False, '')
            msg = "Código %r não cadastrado na coluna 'supfec_codigo_na_ecf' " \
                  "da tabela 'cad_finalizadora_na_ecf'.\n" \
                  'Verique os parametros de Sangria no PDV-Config!' % par_s[1]
            message_dlg(self.parent, MSG_ERROR, msg)
            return False
        else:
            nome_finalizadora = finalizadora.name
            codigo_finalizadora = finalizadora.supfec_codigo_na_ecf

        marca_ecf = self.printer.brand
        if marca_ecf in ['bematech', 'daruma']:
            try:
                if _type == 'SA':
                    self.send_command(
                        "till_remove_cash(%r, text='%s')" % (value,
                                                             nome_finalizadora.ljust(16, ' ')))
                elif _type == 'RC':
                    self.printer._add_voucher('%02d' % int(config['totalizador_recarga_cel']), value,
                                              cod_fin=codigo_finalizadora,
                                              text=str(nome_finalizadora.ljust(16, ' ')))
            except (PaymentAdditionError, CommandError):
                message_dlg(self.parent, MSG_INFO,
                            'A forma de pagamento %r não está cadastrada na ECF!'
                            % nome_finalizadora)
                return False
        elif marca_ecf == 'elgin':
            try:
                if _type == 'SA':
                    self.printer.till_remove_cash(value, cod=int(config['sangria_dinheiro'][:2]),
                                                  text=str(nome_finalizadora))
                elif _type == 'RC':
                    self.printer._add_voucher(config['totalizador_recarga_cel'], value,
                                              codigo_finalizadora)
            except:
                self.parent.tratar_except()
        elif marca_ecf == 'sweda':
            try:
                if _type == 'SA':
                    self.printer.till_remove_cash(value, cod=int(par_s[0]),
                                                  text=str(nome_finalizadora))
                elif _type == 'RC':
                    self.printer._add_value_to_counter(value, cod=int(par_s[0]))
            except CodigoInvalido as err:
                message_dlg(self.parent, MSG_ERROR,
                            'Totalizador não fiscal = %r Cadastrado no PDV_Config é inválido!'
                            % par_s[0])
                try:
                    self.printer.cancel()
                    from sigpdv.control.relatorio_gerencial import GerencialReport
                    GerencialReport(loja_id=self.parent.loja.supcfc_loja,
                                    caixa_id=self.parent.caixa_id,
                                    operador_id=self.parent.user_logged.id,
                                    nro_cupom_vinculado=self.parent._coupon_id,
                                    tipo='N', tipo_c='CN',
                                    parent=self.parent)
                    return False
                except:
                    self.parent.tratar_except()
            except:
                self.parent.tratar_except()

        return True

    @Log
    def get_tributos_ecf(self):
        """
        Retorna todos os dados das tributacoes cadastradas no ECF
        """
        trib = self.send_command("get_tax()")
        return trib