import math
from decimal import Decimal

TWOPLACES = Decimal(10) ** -2
TREEPLACES = Decimal(10) ** -3

def r1(f, p):
    return float(Decimal(str(f)).quantize(Decimal(str(pow(10,-p)))))

def r2(f, p=0):
    if isinstance(f, Decimal):
        f = float(f)
    res = round(f + cmp(f, 0.0) * (.1 / pow(10, p+5)), p)
    return Decimal(str(res))


#v = [58.93497, 93.58746, 667.4756, 667.4856, 667.4850, 2.916]
#for f in v:
#    print f, '->', r1(f, 2), r2(f, 2), round(f, 2)


def trunc(v, d=2):
    if isinstance(v, Decimal):
        v = float(v)
    r = int(v * math.pow(10, d)) / math.pow(10, d)

    c = Decimal(10) ** -d
    return Decimal(str(r)).quantize(c)

#v = 9.4 * 0.678
#v = 1.29 * 0.676
#v = 4.99 * 0.268
#v = 7.76 * 0.676
#print 0.676 * 7.76

def get_qtda_trunc(qtd, vlr, vlr_r=0):
    if isinstance(qtd, Decimal):
        qtd = float(qtd)
    if isinstance(vlr, Decimal):
        vlr = float(vlr)
    if isinstance(vlr_r, Decimal):
        vlr_r = float(vlr_r)
    arredondado = r2(qtd * vlr, 2) # Valor Arredondado
    truncado = trunc(qtd * vlr, 2) # Valor Truncado
    print '>>>', truncado, arredondado, qtd
    if vlr_r:
        print 'tem vlr', vlr, vlr_r
        arredondado = vlr_r

    while truncado < arredondado:
        print '>', truncado < arredondado
        qtd += 0.001
        truncado = r2(qtd * vlr, 2)
    return Decimal(str(qtd)).quantize(TREEPLACES)
from time import sleep
def ajusta_qtd_trunc(v1, v2, vlr=r2(12.25)):
    print '->', v1, v2
    if isinstance(v1, Decimal):
        v1 = float(v1)
    if isinstance(v2, Decimal):
        v2 = float(v2)
    qtd = v2 / v1
    vlr_t = trunc(qtd * v1, 2)
    vlr_r = r2(qtd * v1)
    print 'QTD', round(qtd, 3), vlr_t, vlr_r
    print '-', Decimal(str(qtd)).quantize(TREEPLACES), Decimal(str(vlr_t)).quantize(TWOPLACES), Decimal(str(vlr_r)).quantize(TWOPLACES)
    print '-', vlr_t, vlr
    inc = 0
    qtd_min = qtd_max = qtd
    while vlr_t != vlr:
        inc += 1
        qtd_min += 0.001
        qtd_max -= 0.001

        vlr_min = r2(qtd_min * float(v1), 2)
        vlr_max = r2(qtd_max * float(v1), 2)

        print '-', vlr_min, '+', vlr_max, '|', r2(vlr), trunc(vlr_min), trunc(vlr_max)
        if trunc(vlr_max) == trunc(vlr):
            print 'FIM +', Decimal(str(qtd)).quantize(TREEPLACES), Decimal(str(qtd_max)).quantize(TREEPLACES)
            break
        elif trunc(vlr_min) == trunc(vlr):
            print 'FIM -', Decimal(str(qtd)).quantize(TREEPLACES), qtd_min
            break
#        sleep(0.050)
    print 'I',inc
#print '===', Decimal(Decimal('0.674') * Decimal('7.76')).quantize(TWOPLACES), trunc(0.675 * 7.76)

#v_venda = Decimal('5.25')
#v_item = Decimal('7.76')
#qtd = v_venda / v_item
#ajusta_qtd_trunc(v_item, v_venda)
#print get_qtda_trunc(qtd, v_item)
#    arredondado = r2(qtd * vlr, 2) # Valor Arredondado
#    truncado = trunc(qtd * vlr, 2) # Valor Truncado
#    print '>>>', truncado, arredondado, qtd
#    if vlr_r:
#        print 'tem vlr', vlr, vlr_r
#        arredondado = vlr_r
#
#    while truncado < arredondado:
#        print '>', truncado < arredondado
#        qtd += 0.001
#        truncado = r2(qtd * vlr, 2)
#    return Decimal(str(qtd)).quantize(TREEPLACES)


#pi = Decimal('11.90')
#q = Decimal('0.298')
#pv = Decimal('3.55')
#
#pi = Decimal('7.76')
#q = Decimal('0.676')
#pv = Decimal('5.25')
#print pi, q, pv
#qt =  Decimal(pv / pi).quantize(TREEPLACES)
#print qt, Decimal(qt * pi).quantize(TWOPLACES)


#vr_item = Decimal('1.29').quantize(TWOPLACES)
#vr_etq = Decimal('0.87').quantize(TWOPLACES)
#0.676 5.24 5.25 7.76





if __name__ == '__main__':
#    vr_item = Decimal('17.53').quantize(TWOPLACES)
#    vr_etq = Decimal('4.70').quantize(TWOPLACES)
#    qtda = ajusta_qtd(vr_item, vr_etq)
#    q = Decimal(qtda[0] * vr_item).quantize(TWOPLACES)
#    print '>>', qtda, q, r1(q, 2), r2(q, 2), '<<'
#    print Decimal(str(0.268 * 17.54)).quantize(TWOPLACES)
    a = 12.29 / 3
    print trunc(a)
    print round(a)