# -*- coding: utf-8 -*-

import os
from version import version, revision

root_path = os.path.dirname(os.path.realpath(__file__))

__autor__ = u'Dener Rodrigues'

LISTA_APPS = (
    os.path.join(root_path, 'sigfrente'),
    os.path.join(root_path, 'signfe'),
    os.path.join(root_path, 'sigdav'),
    os.path.join(root_path, 'pdvconfig'),
    os.path.join(root_path, 'sigpve')
)

MAIN_APP = LISTA_APPS[0]


def get_version(color=False):
    __version__ = u'%s.%s SVN-%s%s' % tuple([str(e).upper() for e in version])

    if color:
        line = '*' * (len(version) + 2)
        vc = '\033[01;32m%s\033[00;37m\n' % line
        vc += '\033[01;31m ' + version + '\033[00;37m\n'
        vc += '\033[01;32m%s\033[00;37m' % line
        return vc

    return __version__


print get_version()
