/*
  MENUS.CPP
  
  Rotinas para gerenciamento de menus
*/  

#include <stdio.h>
#include <stdlib.h>
#include "menus.hpp"


short int MENU::Executar (struct ITEM *Menu, char *pszTitulo)
{  short int Itens;
   unsigned char Opcao;
   short int Retorno;
   struct ITEM *Item;


   Retorno = CONTINUAR;

   while (Retorno == CONTINUAR)
   {
// Impressão dos itens do menu...
      printf ("\r\n\n\n%s\n\n", pszTitulo);
      for (Itens = 0; Menu[Itens].Titulo != 0; Itens++)
          printf ("    %d. %s\r\n", Itens + 1, Menu[Itens].Titulo);

// Seleção....
      do
      {  printf ("\nTecle o número da opção desejada: ");
         while ((Opcao = getchar()) < ' ' && Opcao != 27) { }
      } while ((Opcao < '1' || Opcao > ('0' + Itens)) && Opcao != 27);


// Execução...
      Item = Menu + (Opcao - '1');

      if (Opcao == 27 || Item->Executar == 0)
         return CONTINUAR;

      Retorno = Item->Executar (Item);
   }
   return Retorno == ENCERRAR_MENU ? CONTINUAR : Retorno;
}


short int MENU::Submenu (struct ITEM* Item)
{  return Executar ((struct ITEM*) Item->Parametro, Item->Titulo);
}
