__author__ = 'Dener Rodrigues'

import subprocess
from threading import Thread


class Socat(object):
    def __init__(self):
        self.socatConnection = None

    def getSocatConnection(self):
        return self.socatConnection

    def setSocatConnection(self, socatConnection):
        self.socatConnection = socatConnection
        return socatConnection

    def connect(self, host, port):
        cont = 0
        while not self.checkProcess():
            cont += 1
            if cont == 5 or not self.checkHost(host):
                raise Exception('socat failed')
            cmd = "/bin/sh -c 'socat pty,link=/dev/ttyV0,waitslave tcp:%s:%s' &" % (host, port)
            sp = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
            self.setSocatConnection(sp)
        return self.getSocatConnection()

    @staticmethod
    def checkProcess():
        cmd = "ps -aux | grep socat | grep -v grep"
        sp = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        stdout = sp.stdout.read()
        return stdout

    @staticmethod
    def checkHost(host):
        res = False
        cmd = "ping -c1 %s" % host
        sp = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        stdout = sp.stdout.read()
        if "64 bytes from" in stdout:
            res = True
        return res

    def run(self, host, port):
        thread_socat = Thread(target=self.connect(host, port))
        thread_socat.start()